diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-ppdu.cc ns-3.39/src/wifi/model/eht/eht-ppdu.cc
--- ns-3.38/src/wifi/model/eht/eht-ppdu.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/eht-ppdu.cc	2023-07-05 14:23:48.109428400 -0700
@@ -22,6 +22,7 @@
 #include "eht-phy.h"
 
 #include "ns3/log.h"
+#include "ns3/wifi-phy-operating-channel.h"
 #include "ns3/wifi-psdu.h"
 
 namespace ns3
@@ -31,34 +32,62 @@
 
 EhtPpdu::EhtPpdu(const WifiConstPsduMap& psdus,
                  const WifiTxVector& txVector,
-                 uint16_t txCenterFreq,
+                 const WifiPhyOperatingChannel& channel,
                  Time ppduDuration,
-                 WifiPhyBand band,
                  uint64_t uid,
                  TxPsdFlag flag)
-    : HePpdu(psdus, txVector, txCenterFreq, ppduDuration, band, uid, flag)
+    : HePpdu(psdus, txVector, channel, ppduDuration, uid, flag)
 {
-    NS_LOG_FUNCTION(this << psdus << txVector << txCenterFreq << ppduDuration << band << uid
-                         << flag);
+    NS_LOG_FUNCTION(this << psdus << txVector << channel << ppduDuration << uid << flag);
+    SetPhyHeaders(txVector, ppduDuration);
+}
+
+void
+EhtPpdu::SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration)
+{
+    NS_LOG_FUNCTION(this << txVector << ppduDuration);
+    SetEhtPhyHeader(txVector);
+}
 
-    // For EHT SU transmissions (carried in EHT MU PPDUs), we have to:
-    // - store the EHT-SIG content channels
-    // - store the MCS and the number of streams for the data field
-    // because this is not done by the parent class.
-    // This is a workaround needed until we properly implement 11be PHY headers.
-    if (ns3::IsDlMu(m_preamble) && !txVector.IsDlMu())
-    {
-        m_contentChannelAlloc = txVector.GetContentChannelAllocation();
-        m_ruAllocation = txVector.GetRuAllocation();
-        m_ehtSuMcs = txVector.GetMode().GetMcsValue();
-        m_ehtSuNStreams = txVector.GetNss();
+void
+EhtPpdu::SetEhtPhyHeader(const WifiTxVector& txVector)
+{
+    const auto bssColor = txVector.GetBssColor();
+    NS_ASSERT(bssColor < 64);
+    if (ns3::IsDlMu(m_preamble))
+    {
+        const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(20);
+        m_ehtPhyHeader.emplace<EhtMuPhyHeader>(EhtMuPhyHeader{
+            .m_bandwidth = GetChannelWidthEncodingFromMhz(txVector.GetChannelWidth()),
+            .m_bssColor = bssColor,
+            .m_ppduType = txVector.GetEhtPpduType(),
+            .m_ehtSigMcs = txVector.GetSigBMode().GetMcsValue(),
+            .m_giLtfSize = GetGuardIntervalAndNltfEncoding(txVector.GetGuardInterval(),
+                                                           2 /*NLTF currently unused*/),
+            /* See section 36.3.12.8.2 of IEEE 802.11be D3.0 (EHT-SIG content channels):
+             * In non-OFDMA transmission, the Common field of the EHT-SIG content channel does not
+             * contain the RU Allocation subfield. For non-OFDMA transmission except for EHT
+             * sounding NDP, the Common field of the EHT-SIG content channel is encoded together
+             * with the first User field and this encoding block contains a CRC and Tail, referred
+             * to as a common encoding block. */
+            .m_ruAllocationA =
+                txVector.IsMu() ? std::optional{txVector.GetRuAllocation(p20Index)} : std::nullopt,
+            // TODO: RU Allocation-B not supported yet
+            .m_contentChannels = GetEhtSigContentChannels(txVector, p20Index)});
+    }
+    else if (ns3::IsUlMu(m_preamble))
+    {
+        m_ehtPhyHeader.emplace<EhtTbPhyHeader>(EhtTbPhyHeader{
+            .m_bandwidth = GetChannelWidthEncodingFromMhz(txVector.GetChannelWidth()),
+            .m_bssColor = bssColor,
+            .m_ppduType = txVector.GetEhtPpduType()});
     }
 }
 
 WifiPpduType
 EhtPpdu::GetType() const
 {
-    if (m_muUserInfos.empty())
+    if (m_psdus.count(SU_STA_ID) > 0)
     {
         return WIFI_PPDU_TYPE_SU;
     }
@@ -77,40 +106,111 @@
 bool
 EhtPpdu::IsDlMu() const
 {
-    return (m_preamble == WIFI_PREAMBLE_EHT_MU) && !m_muUserInfos.empty();
+    return (m_preamble == WIFI_PREAMBLE_EHT_MU) && (m_psdus.count(SU_STA_ID) == 0);
 }
 
 bool
 EhtPpdu::IsUlMu() const
 {
-    return (m_preamble == WIFI_PREAMBLE_EHT_TB) && !m_muUserInfos.empty();
+    return (m_preamble == WIFI_PREAMBLE_EHT_TB) && (m_psdus.count(SU_STA_ID) == 0);
 }
 
 void
-EhtPpdu::SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
-                                   const LSigHeader& lSig,
-                                   const HeSigHeader& heSig) const
-{
-    txVector.SetMode(EhtPhy::GetEhtMcs(m_ehtSuMcs));
-    txVector.SetChannelWidth(heSig.GetChannelWidth());
-    txVector.SetNss(m_ehtSuNStreams);
-    txVector.SetGuardInterval(heSig.GetGuardInterval());
-    txVector.SetBssColor(heSig.GetBssColor());
-    txVector.SetLength(lSig.GetLength());
+EhtPpdu::SetTxVectorFromPhyHeaders(WifiTxVector& txVector) const
+{
+    txVector.SetLength(m_lSig.GetLength());
     txVector.SetAggregation(m_psdus.size() > 1 || m_psdus.begin()->second->IsAggregate());
-    if (!m_muUserInfos.empty())
+    if (ns3::IsDlMu(m_preamble))
     {
-        txVector.SetEhtPpduType(0); // FIXME set to 2 for DL MU-MIMO (non-OFDMA) transmission
+        auto ehtPhyHeader = std::get_if<EhtMuPhyHeader>(&m_ehtPhyHeader);
+        NS_ASSERT(ehtPhyHeader);
+        txVector.SetChannelWidth(GetChannelWidthMhzFromEncoding(ehtPhyHeader->m_bandwidth));
+        txVector.SetBssColor(ehtPhyHeader->m_bssColor);
+        txVector.SetEhtPpduType(ehtPhyHeader->m_ppduType);
+        txVector.SetSigBMode(HePhy::GetVhtMcs(ehtPhyHeader->m_ehtSigMcs));
+        txVector.SetGuardInterval(GetGuardIntervalFromEncoding(ehtPhyHeader->m_giLtfSize));
+        const auto ruAllocation = ehtPhyHeader->m_ruAllocationA; // RU Allocation-B not supported
+                                                                 // yet
+        if (const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(20);
+            ruAllocation.has_value())
+        {
+            txVector.SetRuAllocation(ruAllocation.value(), p20Index);
+            SetHeMuUserInfos(txVector, ruAllocation.value(), ehtPhyHeader->m_contentChannels);
+        }
+        if (ehtPhyHeader->m_ppduType == 1) // EHT SU
+        {
+            NS_ASSERT(ehtPhyHeader->m_contentChannels.size() == 1 &&
+                      ehtPhyHeader->m_contentChannels.front().size() == 1);
+            txVector.SetMode(
+                EhtPhy::GetEhtMcs(ehtPhyHeader->m_contentChannels.front().front().mcs));
+            txVector.SetNss(ehtPhyHeader->m_contentChannels.front().front().nss);
+        }
+    }
+    else if (ns3::IsUlMu(m_preamble))
+    {
+        auto ehtPhyHeader = std::get_if<EhtTbPhyHeader>(&m_ehtPhyHeader);
+        NS_ASSERT(ehtPhyHeader);
+        txVector.SetChannelWidth(GetChannelWidthMhzFromEncoding(ehtPhyHeader->m_bandwidth));
+        txVector.SetBssColor(ehtPhyHeader->m_bssColor);
+        txVector.SetEhtPpduType(ehtPhyHeader->m_ppduType);
     }
-    for (const auto& muUserInfo : m_muUserInfos)
+}
+
+std::pair<std::size_t, std::size_t>
+EhtPpdu::GetNumRusPerEhtSigBContentChannel(uint16_t channelWidth,
+                                           uint8_t ehtPpduType,
+                                           const RuAllocation& ruAllocation)
+{
+    if (ehtPpduType == 1)
     {
-        txVector.SetHeMuUserInfo(muUserInfo.first, muUserInfo.second);
+        return {1, 0};
     }
-    if (ns3::IsDlMu(m_preamble))
+    return HePpdu::GetNumRusPerHeSigBContentChannel(channelWidth, ruAllocation);
+}
+
+HePpdu::HeSigBContentChannels
+EhtPpdu::GetEhtSigContentChannels(const WifiTxVector& txVector, uint8_t p20Index)
+{
+    if (txVector.GetEhtPpduType() == 1)
+    {
+        // according to spec the TXVECTOR shall have a correct STA-ID even for SU transmission,
+        // but this is not set by the MAC for simplification, so set to 0 for now.
+        return HeSigBContentChannels{{{0, txVector.GetNss(), txVector.GetMode().GetMcsValue()}}};
+    }
+    return HePpdu::GetHeSigBContentChannels(txVector, p20Index);
+}
+
+uint32_t
+EhtPpdu::GetEhtSigFieldSize(uint16_t channelWidth,
+                            const RuAllocation& ruAllocation,
+                            uint8_t ehtPpduType)
+{
+    // FIXME: EHT-SIG is not implemented yet, hence this is a copy of HE-SIG-B
+    auto commonFieldSize = 4 /* CRC */ + 6 /* tail */;
+    if (channelWidth <= 40)
+    {
+        commonFieldSize += 8; // only one allocation subfield
+    }
+    else
     {
-        txVector.SetSigBMode(HePhy::GetVhtMcs(heSig.GetMcs()));
-        txVector.SetRuAllocation(m_ruAllocation);
+        commonFieldSize +=
+            8 * (channelWidth / 40) /* one allocation field per 40 MHz */ + 1 /* center RU */;
     }
+
+    auto numRusPerContentChannel =
+        GetNumRusPerEhtSigBContentChannel(channelWidth, ehtPpduType, ruAllocation);
+    auto maxNumRusPerContentChannel =
+        std::max(numRusPerContentChannel.first, numRusPerContentChannel.second);
+    auto maxNumUserBlockFields = maxNumRusPerContentChannel /
+                                 2; // handle last user block with single user, if any, further down
+    std::size_t userSpecificFieldSize =
+        maxNumUserBlockFields * (2 * 21 /* user fields (2 users) */ + 4 /* tail */ + 6 /* CRC */);
+    if (maxNumRusPerContentChannel % 2 != 0)
+    {
+        userSpecificFieldSize += 21 /* last user field */ + 4 /* CRC */ + 6 /* tail */;
+    }
+
+    return commonFieldSize + userSpecificFieldSize;
 }
 
 Ptr<WifiPpdu>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-ppdu.h ns-3.39/src/wifi/model/eht/eht-ppdu.h
--- ns-3.38/src/wifi/model/eht/eht-ppdu.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/eht-ppdu.h	2023-07-05 14:23:48.109428400 -0700
@@ -22,6 +22,8 @@
 
 #include "ns3/he-ppdu.h"
 
+#include <optional>
+
 /**
  * \file
  * \ingroup wifi
@@ -41,39 +43,125 @@
 {
   public:
     /**
+     * PHY header for EHT TB PPDUs
+     */
+    struct EhtTbPhyHeader
+    {
+        // U-SIG fields
+        uint8_t m_phyVersionId{0}; ///< PHY Version Identifier field
+        uint8_t m_bandwidth{0};    ///< Bandwidth field
+        uint8_t m_bssColor{0};     ///< BSS color field
+        uint8_t m_ppduType{0};     ///< PPDU Type And Compressed Mode field
+
+    }; // struct EhtTbPhyHeader
+
+    /**
+     * PHY header for EHT MU PPDUs
+     */
+    struct EhtMuPhyHeader
+    {
+        // U-SIG fields
+        uint8_t m_phyVersionId{0}; ///< PHY Version Identifier field
+        uint8_t m_bandwidth{0};    ///< Bandwidth field
+        uint8_t m_bssColor{0};     ///< BSS color field
+        uint8_t m_ppduType{0};     ///< PPDU Type And Compressed Mode field
+        uint8_t m_ehtSigMcs{0};    ///< EHT-SIG-B MCS
+
+        // EHT-SIG fields
+        uint8_t m_giLtfSize{0}; ///< GI+LTF Size field
+
+        std::optional<RuAllocation> m_ruAllocationA; //!< RU Allocation-A that are going to be
+                                                     //!< carried in EHT-SIG common subfields
+        std::optional<RuAllocation> m_ruAllocationB; //!< RU Allocation-B that are going to be
+                                                     //!< carried in EHT-SIG common subfields
+
+        HeSigBContentChannels m_contentChannels; //!< EHT-SIG Content Channels
+    };                                           // struct EhtMuPhyHeader
+
+    /// type of the EHT PHY header
+    using EhtPhyHeader = std::variant<std::monostate, EhtTbPhyHeader, EhtMuPhyHeader>;
+
+    /**
      * Create an EHT PPDU, storing a map of PSDUs.
      *
      * This PPDU can either be UL or DL.
      *
      * \param psdus the PHY payloads (PSDUs)
      * \param txVector the TXVECTOR that was used for this PPDU
-     * \param txCenterFreq the center frequency (MHz) that was used for this PPDU
+     * \param channel the operating channel of the PHY used to transmit this PPDU
      * \param ppduDuration the transmission duration of this PPDU
-     * \param band the WifiPhyBand used for the transmission of this PPDU
      * \param uid the unique ID of this PPDU or of the triggering PPDU if this is an EHT TB PPDU
      * \param flag the flag indicating the type of Tx PSD to build
      */
     EhtPpdu(const WifiConstPsduMap& psdus,
             const WifiTxVector& txVector,
-            uint16_t txCenterFreq,
+            const WifiPhyOperatingChannel& channel,
             Time ppduDuration,
-            WifiPhyBand band,
             uint64_t uid,
             TxPsdFlag flag);
 
     WifiPpduType GetType() const override;
     Ptr<WifiPpdu> Copy() const override;
 
+    /**
+     * Get the number of RUs per EHT-SIG-B content channel.
+     * This function will be used once EHT PHY headers are implemented.
+     *
+     * \param channelWidth the channel width occupied by the PPDU (in MHz)
+     * \param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
+     * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
+
+     * \return a pair containing the number of RUs in each EHT-SIG-B content channel (resp. 1 and 2)
+     */
+    static std::pair<std::size_t, std::size_t> GetNumRusPerEhtSigBContentChannel(
+        uint16_t channelWidth,
+        uint8_t ehtPpduType,
+        const std::vector<uint8_t>& ruAllocation);
+
+    /**
+     * Get the EHT-SIG content channels for a given PPDU
+     * IEEE 802.11be-D3.1 36.3.12.8.2 EHT-SIG content channels
+     *
+     * \param txVector the TXVECTOR used for the PPDU
+     * \param p20Index the index of the primary20 channel
+     * \return EHT-SIG content channels
+     */
+    static HeSigBContentChannels GetEhtSigContentChannels(const WifiTxVector& txVector,
+                                                          uint8_t p20Index);
+
+    /**
+     * Get variable length EHT-SIG field size
+     * \param channelWidth the channel width occupied by the PPDU (in MHz)
+     * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
+     * \param ehtPpduType the EHT_PPDU_TYPE used by the PPDU
+     * \return field size in bytes
+     */
+    static uint32_t GetEhtSigFieldSize(uint16_t channelWidth,
+                                       const std::vector<uint8_t>& ruAllocation,
+                                       uint8_t ehtPpduType);
+
   private:
     bool IsDlMu() const override;
     bool IsUlMu() const override;
-    void SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
-                                   const LSigHeader& lSig,
-                                   const HeSigHeader& heSig) const override;
-
-    uint8_t m_ehtSuMcs{0};      //!< EHT-MCS for EHT SU transmissions
-    uint8_t m_ehtSuNStreams{1}; //!< Number of streams for EHT SU transmissions
-};                              // class EhtPpdu
+    void SetTxVectorFromPhyHeaders(WifiTxVector& txVector) const override;
+
+    /**
+     * Fill in the PHY headers.
+     *
+     * \param txVector the TXVECTOR that was used for this PPDU
+     * \param ppduDuration the transmission duration of this PPDU
+     */
+    void SetPhyHeaders(const WifiTxVector& txVector, Time ppduDuration);
+
+    /**
+     * Fill in the EHT PHY header.
+     *
+     * \param txVector the TXVECTOR that was used for this PPDU
+     */
+    void SetEhtPhyHeader(const WifiTxVector& txVector);
+
+    EhtPhyHeader m_ehtPhyHeader; //!< the EHT PHY header
+};                               // class EhtPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/emlsr-manager.cc ns-3.39/src/wifi/model/eht/emlsr-manager.cc
--- ns-3.38/src/wifi/model/eht/emlsr-manager.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.39/src/wifi/model/eht/emlsr-manager.cc	2023-07-05 14:23:48.109428400 -0700
@@ -0,0 +1,341 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#include "emlsr-manager.h"
+
+#include "eht-configuration.h"
+#include "eht-frame-exchange-manager.h"
+
+#include "ns3/abort.h"
+#include "ns3/assert.h"
+#include "ns3/attribute-container.h"
+#include "ns3/log.h"
+#include "ns3/wifi-mpdu.h"
+
+namespace ns3
+{
+
+NS_LOG_COMPONENT_DEFINE("EmlsrManager");
+
+NS_OBJECT_ENSURE_REGISTERED(EmlsrManager);
+
+TypeId
+EmlsrManager::GetTypeId()
+{
+    static TypeId tid =
+        TypeId("ns3::EmlsrManager")
+            .SetParent<Object>()
+            .SetGroupName("Wifi")
+            .AddAttribute("EmlsrPaddingDelay",
+                          "The EMLSR Paddind Delay (not used by AP MLDs). "
+                          "Possible values are 0 us, 32 us, 64 us, 128 us or 256 us.",
+                          TimeValue(MicroSeconds(0)),
+                          MakeTimeAccessor(&EmlsrManager::m_emlsrPaddingDelay),
+                          MakeTimeChecker(MicroSeconds(0), MicroSeconds(256)))
+            .AddAttribute("EmlsrTransitionDelay",
+                          "The EMLSR Transition Delay (not used by AP MLDs). "
+                          "Possible values are 0 us, 16 us, 32 us, 64 us, 128 us or 256 us.",
+                          TimeValue(MicroSeconds(0)),
+                          MakeTimeAccessor(&EmlsrManager::m_emlsrTransitionDelay),
+                          MakeTimeChecker(MicroSeconds(0), MicroSeconds(256)))
+            .AddAttribute(
+                "EmlsrLinkSet",
+                "IDs of the links on which EMLSR mode will be enabled. An empty set "
+                "indicates to disable EMLSR.",
+                AttributeContainerValue<UintegerValue>(),
+                MakeAttributeContainerAccessor<UintegerValue>(&EmlsrManager::SetEmlsrLinks),
+                MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()));
+    return tid;
+}
+
+EmlsrManager::EmlsrManager()
+{
+    NS_LOG_FUNCTION(this);
+}
+
+EmlsrManager::~EmlsrManager()
+{
+    NS_LOG_FUNCTION_NOARGS();
+}
+
+void
+EmlsrManager::DoDispose()
+{
+    NS_LOG_FUNCTION(this);
+    m_staMac->TraceDisconnectWithoutContext("AckedMpdu", MakeCallback(&EmlsrManager::TxOk, this));
+    m_staMac->TraceDisconnectWithoutContext("DroppedMpdu",
+                                            MakeCallback(&EmlsrManager::TxDropped, this));
+    m_staMac = nullptr;
+    m_transitionTimeoutEvent.Cancel();
+    Object::DoDispose();
+}
+
+void
+EmlsrManager::SetWifiMac(Ptr<StaWifiMac> mac)
+{
+    NS_LOG_FUNCTION(this << mac);
+    NS_ASSERT(mac);
+    m_staMac = mac;
+
+    NS_ABORT_MSG_IF(!m_staMac->GetEhtConfiguration(), "EmlsrManager requires EHT support");
+    NS_ABORT_MSG_IF(m_staMac->GetNLinks() <= 1, "EmlsrManager can only be installed on MLDs");
+    NS_ABORT_MSG_IF(m_staMac->GetTypeOfStation() != STA,
+                    "EmlsrManager can only be installed on non-AP MLDs");
+
+    m_staMac->TraceConnectWithoutContext("AckedMpdu", MakeCallback(&EmlsrManager::TxOk, this));
+    m_staMac->TraceConnectWithoutContext("DroppedMpdu",
+                                         MakeCallback(&EmlsrManager::TxDropped, this));
+}
+
+const std::set<uint8_t>&
+EmlsrManager::GetEmlsrLinks() const
+{
+    return m_emlsrLinks;
+}
+
+Ptr<StaWifiMac>
+EmlsrManager::GetStaMac() const
+{
+    return m_staMac;
+}
+
+Ptr<EhtFrameExchangeManager>
+EmlsrManager::GetEhtFem(uint8_t linkId) const
+{
+    return StaticCast<EhtFrameExchangeManager>(m_staMac->GetFrameExchangeManager(linkId));
+}
+
+void
+EmlsrManager::SetTransitionTimeout(Time timeout)
+{
+    NS_LOG_FUNCTION(this << timeout.As(Time::US));
+    m_emlsrTransitionTimeout = timeout;
+}
+
+std::optional<Time>
+EmlsrManager::GetTransitionTimeout() const
+{
+    return m_emlsrTransitionTimeout;
+}
+
+void
+EmlsrManager::SetEmlsrLinks(const std::set<uint8_t>& linkIds)
+{
+    NS_LOG_FUNCTION(this);
+    NS_ABORT_MSG_IF(linkIds.size() == 1, "Cannot enable EMLSR mode on a single link");
+
+    if (linkIds != m_emlsrLinks)
+    {
+        m_nextEmlsrLinks = linkIds;
+    }
+
+    if (GetStaMac() && GetStaMac()->IsAssociated() && GetTransitionTimeout() && m_nextEmlsrLinks)
+    {
+        // Request to enable EMLSR mode on the given links, provided that they have been setup
+        SendEmlOperatingModeNotification();
+    }
+}
+
+void
+EmlsrManager::NotifyMgtFrameReceived(Ptr<const WifiMpdu> mpdu, uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << *mpdu << linkId);
+
+    const auto& hdr = mpdu->GetHeader();
+
+    DoNotifyMgtFrameReceived(mpdu, linkId);
+
+    if (hdr.IsAssocResp() && GetStaMac()->IsAssociated() && GetTransitionTimeout() &&
+        m_nextEmlsrLinks && !m_nextEmlsrLinks->empty())
+    {
+        // we just completed ML setup with an AP MLD that supports EMLSR and a non-empty
+        // set of EMLSR links have been configured, hence enable EMLSR mode on those links
+        SendEmlOperatingModeNotification();
+    }
+
+    if (hdr.IsAction() && hdr.GetAddr2() == m_staMac->GetBssid(linkId))
+    {
+        // this is an action frame sent by an AP of the AP MLD we are associated with
+        auto [category, action] = WifiActionHeader::Peek(mpdu->GetPacket());
+        if (category == WifiActionHeader::PROTECTED_EHT &&
+            action.protectedEhtAction ==
+                WifiActionHeader::PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION)
+        {
+            if (m_transitionTimeoutEvent.IsRunning())
+            {
+                // no need to wait until the expiration of the transition timeout
+                m_transitionTimeoutEvent.PeekEventImpl()->Invoke();
+                m_transitionTimeoutEvent.Cancel();
+            }
+        }
+    }
+}
+
+void
+EmlsrManager::SendEmlOperatingModeNotification()
+{
+    NS_LOG_FUNCTION(this);
+
+    NS_ABORT_MSG_IF(!m_emlsrTransitionTimeout,
+                    "AP did not advertise a Transition Timeout, cannot send EML notification");
+    NS_ASSERT_MSG(m_nextEmlsrLinks, "Need to set EMLSR links before calling this method");
+
+    MgtEmlOperatingModeNotification frame;
+
+    // Add the EMLSR Parameter Update field if needed
+    if (m_lastAdvPaddingDelay != m_emlsrPaddingDelay ||
+        m_lastAdvTransitionDelay != m_emlsrTransitionDelay)
+    {
+        m_lastAdvPaddingDelay = m_emlsrPaddingDelay;
+        m_lastAdvTransitionDelay = m_emlsrTransitionDelay;
+        frame.m_emlControl.emlsrParamUpdateCtrl = 1;
+        frame.m_emlsrParamUpdate = MgtEmlOperatingModeNotification::EmlsrParamUpdate{};
+        frame.m_emlsrParamUpdate->paddingDelay =
+            CommonInfoBasicMle::EncodeEmlsrPaddingDelay(m_lastAdvPaddingDelay);
+        frame.m_emlsrParamUpdate->transitionDelay =
+            CommonInfoBasicMle::EncodeEmlsrTransitionDelay(m_lastAdvTransitionDelay);
+    }
+
+    // We must verify that the links included in the given EMLSR link set (if any) have been setup.
+    auto setupLinkIds = m_staMac->GetSetupLinkIds();
+
+    for (auto emlsrLinkIt = m_nextEmlsrLinks->begin(); emlsrLinkIt != m_nextEmlsrLinks->end();)
+    {
+        if (auto setupLinkIt = setupLinkIds.find(*emlsrLinkIt); setupLinkIt != setupLinkIds.cend())
+        {
+            setupLinkIds.erase(setupLinkIt);
+            auto apLinkId = m_staMac->GetApLinkId(*emlsrLinkIt);
+            NS_ASSERT(apLinkId);
+            frame.SetLinkIdInBitmap(*apLinkId);
+            emlsrLinkIt++;
+        }
+        else
+        {
+            NS_LOG_DEBUG("Link ID " << +(*emlsrLinkIt) << " has not been setup");
+            emlsrLinkIt = m_nextEmlsrLinks->erase(emlsrLinkIt);
+        }
+    }
+
+    // EMLSR Mode is enabled if and only if the set of EMLSR links is not empty
+    frame.m_emlControl.emlsrMode = m_nextEmlsrLinks->empty() ? 0 : 1;
+
+    // TODO if this is a single radio non-AP MLD and not all setup links are in the EMLSR link
+    // set, we have to put setup links that are not included in the given EMLSR link set (i.e.,
+    // those remaining in setupLinkIds, if m_nextEmlsrLinks is not empty) in the sleep mode:
+    // For the EMLSR mode enabled in a single radio non-AP MLD, the STA(s) affiliated with
+    // the non-AP MLD that operates on the enabled link(s) that corresponds to the bit
+    // position(s) of the EMLSR Link Bitmap subfield set to 0 shall be in doze state if a
+    // non-AP STA affiliated with the non-AP MLD that operates on one of the EMLSR links is
+    // in awake state. (Sec. 35.3.17 of 802.11be D3.0)
+
+    auto linkId = GetLinkToSendEmlNotification();
+    GetEhtFem(linkId)->SendEmlOperatingModeNotification(m_staMac->GetBssid(linkId), frame);
+}
+
+void
+EmlsrManager::TxOk(Ptr<const WifiMpdu> mpdu)
+{
+    NS_LOG_FUNCTION(this << *mpdu);
+
+    const auto& hdr = mpdu->GetHeader();
+
+    if (hdr.IsAssocReq())
+    {
+        // store padding delay and transition delay advertised in AssocReq
+        MgtAssocRequestHeader assocReq;
+        mpdu->GetPacket()->PeekHeader(assocReq);
+        auto& mle = assocReq.Get<MultiLinkElement>();
+        NS_ASSERT_MSG(mle, "AssocReq should contain a Multi-Link Element");
+        m_lastAdvPaddingDelay = mle->GetEmlsrPaddingDelay();
+        m_lastAdvTransitionDelay = mle->GetEmlsrTransitionDelay();
+    }
+
+    if (hdr.IsMgt() && hdr.IsAction())
+    {
+        if (auto [category, action] = WifiActionHeader::Peek(mpdu->GetPacket());
+            category == WifiActionHeader::PROTECTED_EHT &&
+            action.protectedEhtAction ==
+                WifiActionHeader::PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION)
+        {
+            // the EML Operating Mode Notification frame that we sent has been acknowledged.
+            // Start the transition timeout to wait until the request can be made effective
+            NS_ASSERT_MSG(m_emlsrTransitionTimeout, "No transition timeout received from AP");
+            m_transitionTimeoutEvent = Simulator::Schedule(*m_emlsrTransitionTimeout,
+                                                           &EmlsrManager::ChangeEmlsrMode,
+                                                           this);
+        }
+    }
+}
+
+void
+EmlsrManager::TxDropped(WifiMacDropReason reason, Ptr<const WifiMpdu> mpdu)
+{
+    NS_LOG_FUNCTION(this << reason << *mpdu);
+
+    const auto& hdr = mpdu->GetHeader();
+
+    if (hdr.IsMgt() && hdr.IsAction())
+    {
+        auto pkt = mpdu->GetPacket()->Copy();
+        if (auto [category, action] = WifiActionHeader::Remove(pkt);
+            category == WifiActionHeader::PROTECTED_EHT &&
+            action.protectedEhtAction ==
+                WifiActionHeader::PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION)
+        {
+            // the EML Operating Mode Notification frame has been dropped. Ask the subclass
+            // whether the frame needs to be resent
+            auto linkId = ResendNotification(mpdu);
+            if (linkId)
+            {
+                MgtEmlOperatingModeNotification frame;
+                pkt->RemoveHeader(frame);
+                GetEhtFem(*linkId)->SendEmlOperatingModeNotification(m_staMac->GetBssid(*linkId),
+                                                                     frame);
+            }
+            else
+            {
+                m_nextEmlsrLinks.reset();
+            }
+        }
+    }
+}
+
+void
+EmlsrManager::ChangeEmlsrMode()
+{
+    NS_LOG_FUNCTION(this);
+
+    // After the successful transmission of the EML Operating Mode Notification frame by the
+    // non-AP STA affiliated with the non-AP MLD, the non-AP MLD shall operate in the EMLSR mode
+    // and the other non-AP STAs operating on the corresponding EMLSR links shall transition to
+    // active mode after the transition delay indicated in the Transition Timeout subfield in the
+    // EML Capabilities subfield of the Basic Multi-Link element or immediately after receiving an
+    // EML Operating Mode Notification frame from one of the APs operating on the EMLSR links and
+    // affiliated with the AP MLD. (Sec. 35.3.17 of 802.11be D3.0)
+    NS_ASSERT_MSG(m_nextEmlsrLinks, "No set of EMLSR links stored");
+    m_emlsrLinks.swap(*m_nextEmlsrLinks);
+    m_nextEmlsrLinks.reset();
+
+    // TODO Make other non-AP STAs operating on the corresponding EMLSR links transition to
+    // active mode or passive mode (depending on whether EMLSR mode has been enabled or disabled)
+
+    NotifyEmlsrModeChanged();
+}
+
+} // namespace ns3
